#include "main.h"


void main()
{
  
   int8 i = 0;
   Packet IR_packet, CAN_packet, test;
   int1 CAN_data_ready = 0;
   int16 current_health=1, max_health=1;
   
   initialize();

   
   while(1)
   {

      if(IR_data_ready)
      {
         IR_packet = Incoming_Packet_Parser(&IR_buffer[0], 8);
         /*
         fprintf(USB, "\n\rIR data received: ");
         for(i=0;i<8;i++)
         {
            fprintf(USB, "%u ", IR_buffer[i]);
         }
         fprintf(USB, "\n\r");
        
         fprintf(USB, "\n\rTeam: %u", IR_packet.Team);
         fprintf(USB, "\n\rPlayer: %lu", IR_packet.Player);
         fprintf(USB, "\n\r:Subroutine %u", IR_packet.Subroutine);
         fprintf(USB, "\n\rProcess: %lu", IR_packet.Process);
         fprintf(USB, "\n\rReturnValue: %lu", IR_packet.ReturnValue);
         fprintf(USB, "\n\rChecksum: %u", IR_packet.Checksum);
         fprintf(USB, "\n\r");
         
         */
         
         if(Integrity_Check(&IR_buffer[0]))
         {
            can_putd(0x08, &IR_buffer[0], 8,1,0,0);
            //fprintf(USB, "\n\rChecksum passed. IR packet relayed over CAN");
            //The next section treats IR packets as possible HIU light change packets, which should never happen in game. Used for testing lights
            
            /*
            if(IR_packet.Team == 255) // from HIU to devices
               {
                  
                  if(IR_packet.Player == 0) // From HIU to Headband
                  {
                     change_lights(IR_packet.ReturnValue);
                  }
                         
               }
             //end light test section */
         }
            
         IR_data_ready = 0;
      }
      
      
      if (can_waiting)   //if can rx isr has run and data stored
      {
      
            can_waiting = 0;
            //fprintf(USB, "\n\rGot a CAN packet");
            CAN_packet = Incoming_Packet_Parser(&CAN_buffer[0],8);
            //fprintf(USB, "\n\rProcess=%lu", CAN_packet.Process);
            if(Integrity_Check(&CAN_buffer[0]))
            {
               CAN_data_ready = 1;
            }
         
      
         
         if(CAN_data_ready)
         {
            
                     if(CAN_packet.Process == 4)
                     {
                        current_health = CAN_packet.ReturnValue;
                        ratio = current_health/max_health;
                        update_lights(ratio);
                     }
                     
                     if(CAN_packet.Process == 10)
                     {
                        max_health = CAN_packet.ReturnValue;
                        ratio = current_health/max_health;
                        update_lights(ratio);
                     }
               
            CAN_data_ready = 0;
         }
         
      }
      
      /* //This section waits for a value to be entered over rs-232. This value is put in a packet's RV and the packet sent over CAN.
         //This is used to test CAN functionality and lights on another HB
         
      if (canready)
      {
         test.COM = 0;
         test.Team=255;
         test.Player = 0;
         test.Subroutine =0;
         test.Process = 0;
         test.ReturnValue = lights;
         
         PacketBuilder(test,&testbuffer[0]);
         for(i=0;i<8;i++)
         fprintf(USB,"%u",testbuffer[i]);
         can_putd(0x205, &testbuffer[0], 8,1,1,0);
         canready=0;
      }
      */
   }
}

void initialize()
{
   can_init();
   
   enable_interrupts(int_canrx0); 

   setup_adc_ports(NO_ANALOGS|VSS_VDD);
   setup_adc(ADC_OFF|ADC_TAD_MUL_0);
   setup_spi(SPI_SS_DISABLED);
   setup_wdt(WDT_OFF);
   setup_timer_0(RTCC_INTERNAL | RTCC_DIV_16 );
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DIV_BY_16,141,4);
   setup_timer_3(T3_DISABLED|T3_DIV_BY_1);
   setup_vref(FALSE);
   enable_interrupts(INT_TIMER0);
   enable_interrupts(INT_TIMER2);
   enable_interrupts(INT_EXT);
   EXT_INT_EDGE(H_TO_L);
   //enable_interrupts(INT_RDA);
   enable_interrupts(GLOBAL);

   // Set low all unused pins
   output_low(pin_b4);
   output_low(pin_b5);
   output_low(pin_b1);
   output_low(pin_c3);
   output_low(pin_c4);
   output_low(pin_c0);
   output_low(pin_c1);
   output_low(pin_a2);
   output_low(pin_a3);
   output_low(pin_a4);
   output_low(pin_a5);
   
   //LED power on test sequence
   output_low(GREEN);
   output_low(YELLOW);
   output_low(RED);
   delay_ms(500);
   output_high(GREEN);
   delay_ms(100);
   output_high(YELLOW);
   delay_ms(100);
   output_high(RED);
   delay_ms(100);
   output_low(GREEN);
   delay_ms(100);
   output_low(YELLOW);
   delay_ms(100);
   output_low(RED);
   delay_ms(100);
   
   fprintf(USB, "HB Initialized...\n\r");
}

void update_lights(float rat)
{
   if (rat <= -0.1)
   {
      change_lights(0b00001000);
   }
   
   else if (rat <= 0.0)
   {
      change_lights(0b00001001);
   }
   
   else if (rat <= 0.1)
   {
      change_lights(0b00011000);
   } 
   
   else if (rat <= 0.25)
   {
      change_lights(0b00010010);
   } 
   
   else if (rat <= 0.5)
   {
      change_lights(0b00010000);
   } 
   
   else if (rat <= 0.75)
   {
      change_lights(0b00110000);
   } 
   
   else if (rat < 1.0)
   {
      change_lights(0b00100100);
   } 
   
   else if (rat >= 1.0)
   {
      change_lights(0b00100000);
   } 
}

void change_lights(int16 process)
{
   output_low(GREEN);
   output_low(YELLOW);
   output_low(RED);
   green_countdown = 0;
   yellow_countdown = 0;
   red_countdown = 0;
   
      
   if ((process&0b00100000) > 0)
      output_high(GREEN);
      
   if ((process&0b00010000) > 0)
      output_high(YELLOW);
      
   if ((process&0b00001000) > 0)
      output_high(RED);
      
   if ((process&0b00000100) > 0)
      green_countdown = 1;
      
   if ((process&0b00000010) > 0)
      yellow_countdown = 1;
      
   if ((process&0b00000001) > 0)
      red_countdown = 1;
      
}

#int_TIMER0
void  TIMER0_isr(void) 
{
  // output_toggle(pin_c1);
   if(green_countdown > 0)
   {
      output_toggle(GREEN);
      
      
      if(green_countdown == 0)
      {
         output_high(GREEN);
      }
   }
   
   if(yellow_countdown > 0)
   {
      output_toggle(YELLOW);
      
      
      if(yellow_countdown == 0)
      {
         output_high(YELLOW);
      }
   }
   
   if(red_countdown > 0)
   {
      output_toggle(RED);
      
      
      if(red_countdown == 0)
      {
         output_high(RED);
      }
   }
   
}

#int_RDA
void  RDA_isr(void) 
{
   lights = getc(USB);
   lights &= 0x0F;
   canready = 1;
}

#int_canrx0
void canrx0_int ( ) {

   can_getd(rx_id, &CAN_buffer[0], rx_len, rxstat);
   
   if(rx_id == 0x07)
   {
      can_waiting = 1;
   }
   
}





